

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxgline.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% global line search decreasing fcn(xbest+alp*p) 
% 
% coord:     % k for coordinate search in direction k,
%            % 0 for random direction search
%
% m-file called in main iteration of vx* routines
%

nalp=10;       % number of uniform points tried (>=4)
% the random scale recipe can be tuned as well

if coord>0,
  % coordinate direction
  pp=zeros(n,1);
  pp(coord)=ub(coord)-lb(coord);
else
  % random search direction
  pp=2*(vxrand(lb,ub)-xbest);
end;
% search range alp in [-1,1]
n2=fix(nalp/2);
nalp=2*n2+1;

% global grid search
glgood=0;

for rep=1:10;
  fgline=fbest;

  % random scale
  r=rand^2; 
  p=pp*r;
  asorted=([-n2:n2]+0.8*rand(1,nalp)-0.4)/n2;
  asorted(n2+1)=0;
  fsorted=inf*asorted;

  x0=xbest;
  
  for kk=1:nalp,
    alp=asorted(kk);
    if alp==0, 
      fsorted(kk)=fbest;
      continue; 
    end;
    % function evaluation and list management
    x=x0+asorted(kk)*p;
    vxeval; % evaluate f=f(x) and keep books
    if done, break; end;
    fsorted(kk)=f;
    if f<=fbest,
      % update best point information
      fbest=f;
      xbest=x;
      nfbest=nfused;
    end;
  end;

  [ffbest,kbest]=min(fsorted);
  if fbest<fgline,
    % best point moved on the grid
    glgood=glgood+1;
  else
    break;
  end;
end;
% now the best grid point is at alp=0

bracket=1;
nblist=0;
blist=[];
fblist=[];
for kk=3:nalp-2,

  f0=fsorted(kk);
  f1=fsorted(kk-1);
  f2=fsorted(kk+1);
  if f0>min(f1,f2),
    % not a local minimizer, do nothing
    continue
  end;

  % safeguarded quadratic interpolation step
  a00=asorted(kk);
  a1=asorted(kk-1)-a00;
  a2=asorted(kk+1)-a00;
  %111
  %alp
  vxquad;
  %alp
  %if isnan(alp)
  %    error('abbruch2')
  %end
  %222
  anew=alp+a00;

  % piecewise linear interpolation steps
  kink=-1;
  vxkink;
  if kink, anew=[anew,alp]; end;
  kink=+1;
  vxkink;
  if kink, anew=[anew,alp]; end;
  
  for alp=anew,
    % function evaluation and list management
    x=x0+alp*p;
    vxeval; % evaluate f=f(x) and keep books
    if done, break; end;
    if f<=fbest,
      % update best point information
      fbest=f;
      xbest=x;
      nfbest=nfused;
    end;
    nblist=nblist+1;
    blist(1,nblist)=alp;
    fblist(1,nblist)=f;
  end;

end;

if glgood>0, 
  trygline=maxgline;
else       
  trygline=trygline-1;
end;

