

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxmain.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% variant of VXMIN
%
% m-file called in vxmin.m
%

%%%%%%%%%%%%%%%%%%%%%%%%%%
% set temporary parameters

if n==1, namax=2;
else     namax=max(3,min((n+1)/2,11));    % maximal size of affine basis
end;
% this gives 2 decimals in 100*n (for small n fewer) function values

defacc=eps;
shortfrac=0.5;           % fraction of short scout steps
maxgline=100;
%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%
% rough initial scaling

% smallest point in box      
xorig=zeros(n,1);
ind=(lb>0);
xorig(ind)=lb(ind);     
ind=(ub<0);
xorig(ind)=ub(ind);     
p=xorig-xbest;
if ~all(p==0),
  % scaling line search 
  alp=1;
  keepalp=1;
  vxline;
  if done, return; end;
end;


%%%%%%%%%%%%%%%%
% main iteration

nit=0;
foldit=fbest;
stuck=0;
nstuck=0;
nscout=0;
fscout=fbest;
trygline=maxgline;
while 1
  
  % stopping test
  if done, break; end;

  % update counters
  nit=nit+1;
  na=size(X,2);
  if fbest<foldit,
    if stuck>1, 
      % stuck, 
    end;
    stuck=0;
  elseif na==namax,
    if fbest<foldit, stuck=0;
    else             stuck=stuck+1;
    end;
    %if stuck, disp(['stuck = ',num2str(stuck)]); end;
  end;
  fscout(1,nit)=fbest;
  nfold=nfused;
  
  % hill step
  na=size(X,2);
  if rem(nit+1,namax)==0 & trygline>=0,
    %fbest
    %disp('global coordinate search before scout')
    for coord=1:n,
        %if any(isnan(xbest))
        %    nit
        %    coord
        %    error('abbruch1')
        %end
        vxgline;
    end;
  end;
  
  % scout step
  ns=floor(n/5);
  %disp('scout step')
  
  vxscout;
  if done, break; end;
 
  % find column to replace
  if na<namax, 
    rc=na+1;
  else 
    [fmax,rc]=max(diag(F));
    if f>=fmax,
      % (is essential in some cases even when trygline<<0!)
      %disp('global coordinate search after scout')
      for coord=1:n, vxgline; end;
    end;
  end; 
  
  % disp('subspace step')
  vxsub;
  if done, break; end;
  
end;

% main iteration complete
%%%%%%%%%%%%%%%%%%%%%%%%%

% if stuck, stuck, end;


