

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxnewton.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% find safeguarded Newton direction
%
% m-file called in vxsub.m
%

% negative gradient at best basis point x_rc
b=d/4-F(:,rc);

% steepest descent direction
sS=b-mean(b);
sS=sS/(norm(sS,inf)+realmin);

% Newton direction (is a good spanning direction even when singular)
warning off
ona=ones(na,1);
delta=norm(d-frc,inf);delta=delta(ona,1);
sN=[F-frc delta;delta' 0]\[b;0];sN(end)=[];
sN=sN-mean(sN);
sN=sN/norm(sN,inf);
warning on

if all(isfinite(sN)),
  % minimize in the 2D subspace spanned by sS and sN
  % f(xnew+Qt) = fnew - 4 c2^T t + 2 t^T G2 t
  Q=[sS,sN];
  c2=Q'*b;
  G2=Q'*F*Q; 
  [t,nalp]=vx2quad(c2,G2,n*defacc);
  s=Q*t;
else
  % unstable Newton direction, use only steepest descent
  s=sS;
end;

% shift to affine coordinates
s(rc)=s(rc)+1;

falp=NaN; % function value at new point unknown;

