

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxquad.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% finds alp for a safeguarded quadratic interpolation step
% through a0=0, a1, a2 with function values f0, f1, f2
% 

alpeps=1e-12;  % limit accuracy for convex regularizartion

% get slopes
da1=(f1-fbest)/a1;
da2=(f2-fbest)/a2;

% get interpolating quadratic model
% f(xbest+alp*p)=fbest-alp*kappa+alp^2*lambda

alpf=(max(falist)-fbest+eps*abs(fbest))/max(abs(a1),abs(a2))^2;

lambdamin=alpeps*alpf;
lambda=(da2-da1)/(a2-a1);
kappa=a1*lambda-da1;
kappa2=kappa/2;
convex=bracket|(lambda>lambdamin);  
if 0,
  condinv=min([(f1-fbest)/(abs(f1)+abs(fbest))
              (f2-fbest)/(abs(f2)+abs(fbest))
              (da2-da1)/(abs(da2)+abs(da1))])
end;

if isfinite(linetarget),
  % get maximal step with predicted gain <= linetarget
  discr=kappa2^2-lambda*linetarget;
  if discr>0, 
    if kappa2<0, denom=kappa2-sqrt(discr);
    else         denom=kappa2+sqrt(discr);
    end; 
    alp=linetarget/denom;
  elseif lambda>0,  alp=kappa2/lambda;
  else              alp=0;   % flat function               
  end;
  %%alp%hier weiter
else
  % unrestricted case
  % get safeguarded convex quadratic model
  lambda=max(lambda,lambdamin);
  kappa=a1*lambda-da1;
  % predicted optimal step size
  alp=kappa/(2*lambda);
end;

oldrep=(alp==0|alp==a1|alp==a2); 
if oldrep,
  % replace by random step
  alp=a1+rand*(a2-a1);
end;

