

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxscout.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% creates an improved point using ns random line searches
% 
% m-file called in main iteration of vx* routines
%

% note this currently fixes ns=n!

if exist('S')~=1, 
  % create scout set
  ns=n;
  S=2*rand(n)-1;  
  sscale=iscale;
end;

% create non-affine basis
ns=size(S,2);
ons=ones(ns,1);
[S,R,E]=qr(S-xbest(:,ons));

% determine scale
if sscale(1)==0, scal=iscale;
else            scal=sscale(1);
end;
sscale=scal./[1:n];

% search in each basis direction
for k=1:n,
  % correctly scaled search direction 
  p=sscale(k)*S(:,k);

  % line search towards scout reference point
  alp=1;
  keepalp=1;
  vxline;
  if done, break; end;

  % update basis (the used part of the basis is affine)
  S(:,k)=x;
  fS(1,k)=f;
  sscale(k)=abs(alp)*sscale(k);
end;

% disp(['scout finished with d = ',num2str(d),',  na = ',num2str(na)]);
% next

if prt, 
  disp(['nf=',num2str(nfused),', nit=',num2str(nit),...
        ', fbest=',num2str(fbest)])
end;


