

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% vxsub.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% updates row and column rc of affine quadratic model of size na, 
% assuming that the other rows and columns are ok.
% The new point is assumed to be x and its function value f.
%
% m-file called in main iteration of vx* routines


X;    % affine basis, n x na
F;    % symmetric function matrix, na x na
      % F(i,k)=fcn((x_i+x_k)/2)
fold=fbest;
nfold=nfused;

% update column rc of affine basis
xrc=x;
X(:,rc)=x;
na=size(X,2);

if 0, % never applies before many stucks 
% check hull
xinf=min(X,[],2);
xsup=max(X,[],2);
qhull=max((xsup-xinf)./(abs(xsup)+abs(xinf)+realmin))
if qhull<1e-8,
  % affine restart
  X=xbest;F=fbest;
end;
end; % if 0

% update row and column rc of function matrix
F(rc,rc)=f;
for iu=1:na,
  if iu==rc, continue; end;
  x=(xrc+X(:,iu))/2;
  % evaluate function
  vxeval;
  if f<=fbest,
    % update best point information
    nfbest=nfused;xbest=x;fbest=f;
    if prt, disp('improvement in pair step');end;
  end;
  F(rc,iu)=f;
  F(iu,rc)=f;
end;
% now f(Xs)=(2*s'*F-diag(F)')*s if sum(s)=1
  
% find index of best basis point x_rc
d=diag(F);
[frc,rc]=min(d);

% toggle direction type to be tried
trydirmax=0;
if exist('trydir')~=1,
  trydir=0;
else
  trydir=trydir+1;
  if trydir>trydirmax, trydir=0; end;
end;
switch trydir
case 0
  vxnewton;  % safeguarded Newton direction
otherwise
  vxcov;     % covariance matrix based direction
end;

% search direction
p=X*s-xbest;
if all(p==0), return; end;

% line search
keepalp=0;
vxline;
if done, return; end;





